
program TXTDemo1;       { Demostracin de la unidad CharSet.pas }


uses Mode13, CharSet, Crt;

var ChSet : PTCharSet;          { Juego de caracteres }
    FondoScr : PTVirtual;       { Pantalla virtual para almacenar el fondo }
    FondoSeg : word;            { Segmento de la pantalla virtual }
    pal : TPalette;             { Paleta utilizada }
    i : word;                   { Contador para ciclos }


{ WaitKey - borra el buffer del teclado y espera a que se oprima una tecla }
procedure WaitKey;
begin
     while keypressed do readkey;
     readkey;
end;


begin
     { inicializacin }
     clrscr; writeln; write('  Cargando... fondo');
     { carga la imagen de fondo en una pantalla virtual }
     SetupVirtual(FondoScr, FondoSeg);
     LoadPCX('fondo.pcx', FondoSeg, 320, 200, 0, 0, pal);
     write(' + juego de caracteres...');
     { inicializa y carga juego de caracteres #2 }
     ChSet := new(PTCharSet, Init('charset2.chr'));
     { Como pueden ver, el constructor se llama a la hora de crear el objeto }
     write('    .....LISTO!');
     { Ahora llenamos la paleta con los colores del juego de caracteres }
     { en este caso, los colores usados por el juego de caracteres van  }
     { del 224 al 245, de menor a mayor intensidad.                     }
     for i := 0 to 21 do
     begin
          pal[224 + i][0] := i * 3;
          pal[224 + i][1] := i * 3;
          pal[224 + i][2] := i * 3;
     end;
     pal[255][0] := 63;
     pal[255][1] := 63;
     pal[255][2] := 0;

     delay(1000);       { esperamos un momento... }
     SetMode13;         { y entramos al modo grfico }
     SetPalette(pal);   { aplicamos la paleta }

     { Mostramos la primera parte del texto... }
     CopyScreen(FondoSeg, VGA);     { copiamos el fondo a VGA }
     ChSet^.PrintString(30, 80, 'Estas son las nuevas rutinas', -7, VGA);
     ChSet^.PrintString(60, 97, 'para mostrar TEXTO', -5, VGA);
     ChSet^.PrintString(90, 114, 'en el modo 13h', -6, VGA);
     ChSet^.PrintString(140, 170, 'presiona una tecla', -7, VGA);
     ChSet^.PrintString(85, 185, 'despues de cada pantalla', -7, VGA);
     WaitKey;

     { Carga una nueva fuente (la nmero #1) }
     { (no es necesario destrur el objeto y volverlo a crear!) }
     CopyScreen(FondoSeg, VGA);
     ChSet^.PrintString(40, 90, 'Cargando nueva fuente...', -6, VGA);
     ChSet^.Load('charset1.chr');

     { muestra la siguiente parte de la presentacin... }
     CopyScreen(FondoSeg, VGA);
     ChSet^.PrintString(180, 30, 'TODOS', -5, VGA);
     ChSet^.PrintString(72, 60, 'LOS TIPOS', -5, VGA);
     ChSet^.PrintString(72, 90, 'DE LETRAS', -5, VGA);
     ChSet^.PrintString(18, 120, 'QUE QUIERAS', -5, VGA);
     WaitKey;

     { Carga una nueva fuente (la nmero #3) }
     CopyScreen(FondoSeg, VGA);
     ChSet^.PrintString(45, 70, 'CARGANDO', -5, VGA);
     ChSet^.PrintString(70, 100, 'FUENTE', -5, VGA);
     ChSet^.Load('charset3.chr');

     { muestra la siguiente parte de la demo... }
     CopyScreen(FondoSeg, VGA);
     ChSet^.PrintString(34, 40, 'del tamano que quieras', -5, VGA);
     ChSet^.PrintString(122, 32, '_', 0, VGA); { rayita de la  }
     ChSet^.PrintString(8, 60, 'con los colores que quieras', -5, VGA);
     ChSet^.PrintString(14, 80, 'y los simbolos que quieras', -5, VGA);
     ChSet^.PrintString(15, 130, '!"#,$%:\()*[^]', 5, VGA);
     ChSet^.PrintString(15, 150, '+<>=;-&|{?@''/}', 5, VGA);
     ChSet^.PrintString(15, 170, '> 0123456789 <', 5, VGA);
     WaitKey;

     { Desinicializacin }
     SetTextMode;
     writeln; write('  Liberando memoria...');
     dispose(ChSet, Done);      { destruye el juego de caracteres }
     ShutDownVirtual(FondoScr);   { destruye la pantalla virtual }
     writeln('    .....LISTO!'); writeln;
end.
